' *******************************************************************************************************
' *                                                                                                     *
' *     AiChip_JVM_001.spin ( Skeleton 'sneak preview' code - NOT WORKING )                             *
' *                                                                                                     *
' *******************************************************************************************************

PRI Version
  return String("AiChip_JVM_001")

CON
{

This is an attempt to implement a Java(TM) JVM as proposed by Peter Verkaik on the Propeller Forum.

This design implements the JVM in PASM utilising LMM to overcome the Cog memory restrictions, and to 
pass unimplemented JVM opcodes off to Spin code to aid development. This capability does not exist in
this version.

End-user Java development is undertaken using the Jikes compiler for the Java language and post 
processing by the JavelinDirect linker as used for Parallax JavelinStamp ( suitably modified ). The 
bytecode generated by JavelinDirect is in a .jem bytecode file using JEM Bytecode opcodes which have
different values to Sun's JVM Bytecode opcodes in a .class file although are essentially the same.

Original forum thread : http://forums.parallax.com/forums/default.aspx?f=25&m=244721

}
CON
{

Java and all Java-based marks are trademarks or registered trademarks of Sun Microsystems, Inc. in
the United States and other countries. 

}
CON
{
  
PLEASE NOTE : If modifying and re-releasing this code, please change the prefix of the source file from
              AiChip so as to avoid any confusion as to the origin of the source and update all internal
              references as appropriate. If you wish to credit the orginal source, anything  along the
              lines of, "Based on original AiChip_Jvm_XXX from AiChip Industries", is acceptable.

              AiChip is a trademark of AiChip Industries.

}
CON

' .-----------------------------------------------------------------------------------------------------.
' |     Board Configuration                                                                             |
' `-----------------------------------------------------------------------------------------------------'

  _CLKMODE      = XTAL1 + PLL16x                        ' 80MHz System Clock Speed
  _XINFREQ      = 5_000_000

OBJ

  tv            : "TV_Text"                             ' TV Text Display used for debugging

CON

' .-----------------------------------------------------------------------------------------------------.
' |     Hardware Configuration                                                                          |
' `-----------------------------------------------------------------------------------------------------'

  TV_PIN        = 12                                    ' Base TV Pin

VAR

  long stack[1024]                                      ' Stack area to use 
  long cogDump[$200]                                    ' Copy of cog memory when debug event occurs

PUB Main

  tv.Start( TV_PIN )
  tv.Str( Version )

  CogNew( @Jvm, @stack-4 )
  
  DebugJvm
  
PRI DebugJvm | event, cogAdr

  repeat
    repeat while ( event := long[ $7FF0 ] ) == 0        ' Wait until Lmm VM talks back
    tv.Out( $0D )
    repeat cogAdr from $000 to $1FF
      long[ $7FF0 ] := 0
      repeat while long[ $7FF0] == 0
      cogDump[ cogAdr ] := long[ $7FEC ]
    case event
      1     : IsDebug                                   ' 1 Debug
      2     : IsDebug                                   ' 2 Stop
              tv.Str( String($0D,"Stop") )
              repeat
      3     : IsSingleStep                              ' 3 SingleStep
      4     : IsNotImplemented                          ' 4 NotImplemented
      other : tv.Str( String("Unknown ") )              ' ? Unknown
              tv.Hex( event, 8 )
              repeat
    long[ $7FEC ] := 0                                  ' Let the VM execute another instruction
    long[ $7FF0 ] := 0

PRI IsDebug

  tv.Out( "+")
  tv.Hex( ( Cog(@Debug_Ret) & $1FF ) - 1, 3 )
  tv.Out( " " )
  tv.Hex( long[ $7FF4 ], 8 )
  tv.Out( " " )
  tv.Hex( long[ $7FF8 ], 8 )
  tv.Out( " " )
  tv.Hex( long[ $7FFC ], 8 )
  PauseMs( 1000 )
  
PRI IsSingleStep | xPc, xOp, i

  xPc := Cog(@pc)
  xOp := byte[ xPc ]
  tv.Hex( xPc, 4 )
  tv.out(" ")
  tv.Hex( xPc - @JemBytecodeStart, 3 )   
  tv.out(" ")
  tv.Hex( xOp, 2 )   
  tv.out(" ")
  if xOp < Jem_INSTANCEOF
    case xOp
      Jem_NOP:            i := String("NOP")
      Jem_ICONST_M1:      i := String("ICONST_M1")
      Jem_ICONST_0:       i := String("ICONST_0")
      Jem_ICONST_1:       i := String("ICONST_1")
      Jem_ICONST_2:       i := String("ICONST_2")
      Jem_ICONST_3:       i := String("ICONST_3")
      Jem_ICONST_4:       i := String("ICONST_4")
      Jem_ICONST_5:       i := String("ICONST_5")
      Jem_BIPUSH:         i := String("BIPUSH")
      Jem_SIPUSH:         i := String("SIPUSH")
      Jem_ILOAD:          i := String("ILOAD")
      Jem_ILOAD_0:        i := String("ILOAD_0")
      Jem_ILOAD_1:        i := String("ILOAD_1")
      Jem_ILOAD_2:        i := String("ILOAD_2")
      Jem_ILOAD_3:        i := String("ILOAD_3")
      Jem_ISTORE:         i := String("ISTORE")
      Jem_ISTORE_0:       i := String("ISTORE_0")
      Jem_ISTORE_1:       i := String("ISTORE_1")
      Jem_ISTORE_2:       i := String("ISTORE_2")
      Jem_ISTORE_3:       i := String("ISTORE_3")
      Jem_IFEQ:           i := String("IFEQ")
      Jem_IFNE:           i := String("IFNE")
      Jem_IFLT:           i := String("IFLT")
      Jem_IFLE:           i := String("IFLE")
      Jem_IFGT:           i := String("IFGT")
      Jem_IFGE:           i := String("IFGE")
      Jem_IF_ICMPEQ:      i := String("IF_ICMPEQ")
      Jem_IF_ICMPNE:      i := String("IF_ICMPNE")
      Jem_IF_ICMPLT:      i := String("IF_ICMPLT")
      Jem_IF_ICMPGE:      i := String("IF_ICMPGE")
      Jem_IF_ICMPGT:      i := String("IF_ICMPGT")
      Jem_IF_ICMPLE:      i := String("IF_ICMPLE")
      Jem_IF_ACMPEQ:      i := String("IF_ACMPEQ")
      Jem_IF_ACMPNE:      i := String("IF_ACMPNE")
      Jem_IRETURN:        i := String("IRETURN")
      Jem_RETURN:         i := String("RETURN")
      Jem_INVOKEVIRTUAL:  i := String("INVOKEVIRTUAL")
      Jem_INVOKESTATIC:   i := String("INVOKESTATIC")
      Jem_GETSTATIC:      i := String("GETSTATIC")
      Jem_PUTSTATIC:      i := String("PUTSTATIC")
      Jem_POP:            i := String("POP")
      Jem_POP2:           i := String("POP2")
      Jem_DUP:            i := String("DUP")
      Jem_DUP_X1:         i := String("DUP_X1")
      Jem_DUP_X2:         i := String("DUP_X2")
      Jem_DUP2:           i := String("DUP2")
      Jem_DUP2_X1:        i := String("DUP2_X1")
      Jem_DUP2_X2:        i := String("DUP2_X2")
      Jem_SWAP:           i := String("SWAP")
      Jem_IADD:           i := String("IADD")
      Jem_ISUB:           i := String("ISUB")
      Jem_INEG:           i := String("INEG")
      Jem_IOR:            i := String("IOR")
      Jem_ISHL:           i := String("ISHL")
      Jem_ISHR:           i := String("ISHR")
      Jem_IUSHR:          i := String("IUSHR")
      Jem_IAND:           i := String("IAND")
      Jem_IXOR:           i := String("IXOR")
      Jem_I2B:            i := String("I2B")
      Jem_GOTO:           i := String("GOTO")
      Jem_INVOKEINTERFACE:i := String("INVOKEINTERFACE")
      Jem_ARRAYLENGTH:    i := String("ARRAYLENGTH")
      Jem_ATHROW:         i := String("ATHROW")
      Jem_CHECKCAST:      i := String("CHECKCAST")
  else
    case xOp
      Jem_INSTANCEOF:     i := String("INSTANCEOF")
      Jem_WIDE:           i := String("WIDE")
      Jem_IINC:           i := String("IINC")
      Jem_GETFIELD:       i := String("GETFIELD")
      Jem_PUTFIELD:       i := String("PUTFIELD")
      Jem_NEW:            i := String("NEW")
      Jem_NEWARRAY:       i := String("NEWARRAY")
      Jem_ANEWARRAY:      i := String("ANEWARRAY")
      Jem_IALOAD:         i := String("IALOAD")
      Jem_IASTORE:        i := String("IASTORE")
      Jem_BALOAD:         i := String("BALOAD")
      Jem_BASTORE:        i := String("BASTORE")
      Jem_LDC:            i := String("LDC")
      Jem_LDC_W:          i := String("LDC_W")
      Jem_LDC2_W:         i := String("LDC2_W")
      Jem_IMUL:           i := String("IMUL")
      Jem_IDIV:           i := String("IDIV")
      Jem_IREM:           i := String("IREM")
      Jem_JSR:            i := String("JSR")
      Jem_RET:            i := String("RET")
      Jem_TABLESWITCH:    i := String("TABLESWITCH")
      Jem_LOOKUPSWITCH:   i := String("LOOKUPSWITCH")
      other:              i := String("Unknown")
  if i
    tv.str(i)

PRI IsNotImplemented

  tv.Str( String("Not Implemented before $") )
  tv.Hex( Cog(@pc), 4 )
  repeat

PRI Cog( AtCogAddress )
  result := cogDump[ ( AtCogAddress - @Jvm ) >> 2 ]

PRI PauseMs( mS )
  waitcnt( CLKFREQ / 1000 * mS + CNT )

CON

' *******************************************************************************************************
' *                                                                                                     *
' *     Spin JVM Interpreter                                                                            *
' *                                                                                                     *
' *******************************************************************************************************

  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $34
  Jem_ISHL              = $35
  Jem_ISHR              = $36
  Jem_IUSHR             = $37
  Jem_IAND              = $38
  Jem_IXOR              = $39
  Jem_I2B               = $3A
  Jem_GOTO              = $3B
  Jem_INVOKEINTERFACE   = $3C
  Jem_ARRAYLENGTH       = $3D
  Jem_ATHROW            = $3E
  Jem_CHECKCAST         = $3F
  Jem_INSTANCEOF        = $40
  Jem_WIDE              = $41
  Jem_IINC              = $42
  Jem_GETFIELD          = $43
  Jem_PUTFIELD          = $44
  Jem_NEW               = $45
  Jem_NEWARRAY          = $46
  Jem_ANEWARRAY         = $47
  Jem_IALOAD            = $48
  Jem_IASTORE           = $49
  Jem_BALOAD            = $4A
  Jem_BASTORE           = $4B
  Jem_LDC               = $4C
  Jem_LDC_W             = $4D
  Jem_LDC2_W            = $4E
  Jem_IMUL              = $4F
  Jem_IDIV              = $50
  Jem_IREM              = $51
  Jem_JSR               = $52
  Jem_RET               = $53
  Jem_TABLESWITCH       = $54
  Jem_LOOKUPSWITCH      = $55
  
PRI SpinJvm | xOpc
  
  if xOpc < Jem_INSTANCEOF

    case xOpc
 
      ' .-----------------------------------------------------------------------------------------------.
      ' |       IF_ACMPEQ                                                                           $20 |
      ' |       Meaning: Branch if object references equal.                                             |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_IF_ACMPEQ:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       IF_ACMPNE                                                                           $21 |
      ' |       Meaning: Branch if object references not equal.                                         |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_IF_ACMPNE:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       INVOKEVIRTUAL                                                                       $24 |
      ' |       Meaning: Invoke method based on runtime type.                                           |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_INVOKEVIRTUAL:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       GETSTATIC                                                                           $26 |
      ' |       Meaning: Get 16bit static field from class.                                             |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_GETSTATIC:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       PUTSTATIC                                                                           $27 |
      ' |       Meaning: Set 16bit static field in class.                                               |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_PUTSTATIC:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       DUP_X1                                                                              $2B |
      ' |       Meaning: Duplicate the top word on the stack and insert a copy two words down           |
      ' |       in the stack.                                                                           |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_DUP_X1:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       DUP_X2                                                                              $2C |
      ' |       Meaning: Duplicate the top word on the stack and insert the copy three words            |
      ' |       down in the stack.                                                                      |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_DUP_X2:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       DUP2_X1                                                                             $2E |
      ' |       Meaning: Duplicate the top two words on the stack and insert the copies two             |
      ' |       words down in the stack.                                                                |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_DUP2_X1:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       DUP2_X2                                                                             $2F |
      ' |       Meaning: Duplicate the top two words on the stack and insert the copies three           |
      ' |       words down in the stack.                                                                |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_DUP2_X2:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       INVOKEINTERFACE                                                                     $3C |
      ' |       Meaning: Invoke interface method.                                                       |
      ' |       Note                                                                                    |
      ' |       Unlike invokevirtual and invokespecial, the method block does not indicate the          |
      ' |       number of available arguments. This number is taken from the bytecode.                  |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_INVOKEINTERFACE:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       ARRAYLENGTH                                                                         $3D |
      ' |       Meaning: Get length of array.                                                           |
      ' |       Description: The length of the array is determined and replaces aref on the             |
      ' |       top of the stack. The aref must be a reference to an array object.                      |
      ' |       Note                                                                                    |
      ' |       A NullPointerException is thrown if the aref is null.                                   |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_ARRAYLENGTH:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       ATHROW                                                                              $3E |
      ' |       Meaning: Throw exception or error.                                                      |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_ATHROW:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       CHECKCAST                                                                           $3F |
      ' |       Meaning: Make sure object is of given type.                                             |
      ' |       Description: Determines whether the referenced object can be cast to be a               |
      ' |       reference to an object of another class. A null object reference can be cast to         |
      ' |       any class. Otherwise, the referenced object must be an instance of the expected         |
      ' |       class or one of its superclasses. byte1 and byte2 are used to construct an              |
      ' |       index into the constant pool of the current class, which is presumed to be a            |
      ' |       class name that can be resolved to a class pointer.                                     |
      ' |       Note                                                                                    |
      ' |       A ClassCastException is thrown if the referenced object cannot be cast to the           |
      ' |       expected class.                                                                         |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_CHECKCAST:

  else

    case xOpc
           
      ' .-----------------------------------------------------------------------------------------------.
      ' |       INSTANCEOF                                                                          $40 |
      ' |       Meaning: Determine if an object is of given type and return result.                     |
      ' |       Description: Determines whether the referenced object can be cast to be a               |
      ' |       reference to an object of the expected class. This instruction will overwrite           |
      ' |       the object reference with 1 if the object is an instance of the expected class          |
      ' |       or one of its superclasses. Otherwise, the object reference is overwritten by 0.        |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_INSTANCEOF:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       WIDE                                                                                $41 |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_WIDE:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       GETFIELD                                                                            $43 |
      ' |       Meaning: Get 16bit field from object.                                                   |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_GETFIELD:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       PUTFIELD                                                                            $44 |
      ' |       Meaning: Set 16bit field in object.                                                     |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_PUTFIELD:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       NEW                                                                                 $45 |
      ' |       Meaning: Create new object.                                                             |
      ' |       Description: byte1 and byte2 are used to construct an index into the constant           |
      ' |       pool of the current class, which must be a class name that can be resolved to a         |
      ' |       class pointer. A new instance of that class is then created, and a reference to         |
      ' |       the object is pushed on the stack.                                                      |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_NEW:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       NEWARRAY                                                                            $46 |
      ' |       Meaning: Allocate new array.                                                            |
      ' |       Description: A new array of a specific array type, capable of holding size              |
      ' |       elements, is allocated. The result is a reference to the new object. Allocation         |
      ' |       of an array large enough to contain size items of the specific array type is            |
      ' |       attempted and all elements of the array are initialized to 0.                           |
      ' |       size represents the number of elements in the new array and must be an                  |
      ' |       integer. The result is stored with an internal code that indicates the type of          |
      ' |       array to allocate. Possible values for the type of array are as follows:                |
      ' |       T_BOOLEAN(4), T_chAR(5), T_FLOAT(6), T_DOUBLE(7), T_BYTE(8), T_SHORT(9),                |
      ' |       T_INT(10), and T_LONG(11).                                                              |
      ' |       Note                                                                                    |
      ' |       A NegativeArraySizeException is thrown if size is less than 0. An                       |
      ' |       OutOfMemoryError is thrown if there is not enough memory to allocate the array.         |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_NEWARRAY:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       ANEWARRAY                                                                           $47 |
      ' |       Meaning: Allocate new array of objects.                                                 |
      ' |       Description: A new array of the indicated class type and capable of holding             |
      ' |       size elements is allocated. The result is a reference to the new object.                |
      ' |       Allocation of an array large enough to contain size elements of the given class         |
      ' |       type is attempted and all elements of the array are initialized to null.                |
      ' |       size represents the number of elements in the new array and must be an                  |
      ' |       integer. byte1 and byte2 are used to construct an index into the constant pool          |
      ' |       of the current class. When the item at that index is resolved, the resulting            |
      ' |       entry must be a class.                                                                  |
      ' |       The anewarray instruction is used to create a single-dimension array.                   |
      ' |       Note                                                                                    |
      ' |       A NegativeArraySizeException is thrown if size is less than 0. An                       |
      ' |       OutOfMemoryError is thrown if there is not enough memory to allocate the array.         |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_ANEWARRAY:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       IALOAD                                                                              $48 |
      ' |       Meaning: Load integer from array.                                                       |
      ' |       Description: The integer value at the array index is retrieved and pushed onto          |
      ' |       the top of the stack. The aref must be a reference to an array of integers;             |
      ' |       likewise, the index into the array must be an integer.                                  |
      ' |       Note                                                                                    |
      ' |       A NullPointerException is thrown if aref is null. An                                    |
      ' |       ArrayIndexOutOfBoundsException is thrown if the array index is not within the           |
      ' |       bounds of the array.                                                                    |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_IALOAD:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       IASTORE                                                                             $49 |
      ' |       Meaning: Store into integer array.                                                      |
      ' |       Description: An integer value is popped off the stack and stored in the array           |
      ' |       at the index. The aref must be a reference to an array of integer values, and           |
      ' |       the index into the array must be an integer as well.                                    |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_IASTORE:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       BALOAD                                                                              $4A |
      ' |       Meaning: Load signed byte from array.                                                   |
      ' |       Description: The signed byte value at the array index is retrieved, expanded            |
      ' |       to an integer, and pushed onto the top of the stack. The aref must be a                 |
      ' |       reference to an array of signed byte values, and the index into the array must          |
      ' |       be an integer.                                                                          |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_BALOAD:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       BASTORE                                                                             $4B |
      ' |       Meaning: Store into signed byte array.                                                  |
      ' |       Description: An integer is popped off the stack, converted to a signed byte,            |
      ' |       and stored in the array at the index. The arrayref must be a reference to an            |
      ' |       array of signed bytes, and the index into the array must be an integer. If the          |
      ' |       integer value is too large to be a signed byte, it is truncated.                        |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_BASTORE:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       LDC                                                                                 $4C |
      ' |       Meaning: Push item from constant pool.                                                  |
      ' |       Description: byte1 is used as an unsigned 8-bit index into the constant pool            |
      ' |       of the current class. After the item at that index is resolved, it is pushed            |
      ' |       onto the stack.                                                                         |
      ' |       Note                                                                                    |
      ' |       This bytecode instruction throws an OutOfMemoryError if a String object is              |
      ' |       being pushed and there is not enough memory to allocate space for it.                   |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_LDC:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       LDC_W                                                                               $4D |
      ' |       Meaning: Push 2-byte item from constant pool.                                           |
      ' |       Description: byte1 and byte2 are used to construct an unsigned 16-bit index             |
      ' |       into the constant pool of the current class. After the item at that index is            |
      ' |       resolved, it is pushed onto the stack.                                                  |
      ' |       Note                                                                                    |
      ' |       This bytecode instruction throws an OutOfMemoryError if a String object is              |
      ' |       being pushed and there is not enough memory to allocate space for it.                   |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_LDC_W:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       LDC2_W                                                                              $4E |
      ' |       Meaning: Push long or double from constant pool.                                        |
      ' |       Description: byte1 and byte2 are used to construct an unsigned 16-bit index             |
      ' |       into the constant pool of the current class. After the two-word constant at             |
      ' |       that index is resolved, it is pushed onto the stack.                                    |
      ' |       Note                                                                                    |
      ' |       This bytecode instruction throws an OutOfMemoryError if a String object is              |
      ' |       being pushed and there is not enough memory to allocate space for it.                   |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_LDC2_W:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       IDIV                                                                                $50 |
      ' |       Meaning: Integer divide.                                                                |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_IDIV:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       IREM                                                                                $51 |
      ' |       Meaning: Integer remainder.                                                             |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_IREM:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       TABLESWITCH                                                                         $54 |
      ' |       Meaning: Access jump table by index and jump.                                           |
      ' |       Description: Immediately after the tableswitch instruction, padding consisting          |
      ' |       of 0-3 zeros is inserted so that the next byte begins at an address that is a           |
      ' |       multiple of four. A series of offsets follows the padding. These offsets are            |
      ' |       signed 4-byte quantities and consist of a default offset, a low offset, and a           |
      ' |       high offset, followed by additional high - low + 1 offsets. These additional            |
      ' |       offsets are treated as a 0-based jump table.                                            |
      ' |       The index the offsets point to must be an integer. If the index is less than            |
      ' |       the low offset or greater than the high offset, the default offset is added to          |
      ' |       the address of the current instruction. Otherwise, the low offset is subtracted         |
      ' |       from the index, and the element at the position index - low offset in the jump          |
      ' |       table is extracted and added to the address of the current instruction.                 |
      ' `-----------------------------------------------------------------------------------------------'

      Jem_TABLESWITCH:

      ' .-----------------------------------------------------------------------------------------------.
      ' |       LOOKUPSWITCH                                                                        $55 |
      ' |       Meaning: Access jump table by key match and jump.                                       |
      ' |       Description: Immediately after the lookupswitch instruction, padding                    |
      ' |       consisting of 0-3 zeros is                                                              |
      ' |       inserted so that the next byte begins at an address that is a multiple of               |
      ' |       four. A series of pairs of offsets follows the padding. These offsets are               |
      ' |       signed 4-byte quantities. The first item in the pair is the default offset, and         |
      ' |       the second item in the pair gives the number of pairs that follow. The                  |
      ' |       additional pairs consist of a match and an offset.                                      |
      ' |       The integer key on the stack is then compared against each of the matches. If           |
      ' |       the key is equal to one of the matches, the offset is added to the address of           |
      ' |       the current instruction. If the key does not match any of the matches, the              |
      ' |       default offset is added to the address of the current instruction.                      |
      ' `-----------------------------------------------------------------------------------------------'

DAT

' *******************************************************************************************************
' *                                                                                                     *
' *             JVM Interpreter                                                                         *
' *                                                                                                     *
' *******************************************************************************************************

Jvm             org     $000

' .-----------------------------------------------------------------------------------------------------.
' |             Initialisation / Re-used for Internal Registers                                         |
' `-----------------------------------------------------------------------------------------------------'

                jmp     #JVM_Init

' *******************************************************************************************************
' *                                                                                                     *
' *             Debugging Utilities                                                                     *
' *                                                                                                     *
' *******************************************************************************************************
'
' Debugging uses the top 20 bytes ( 5 longs ) of Ram ( $7FEC to $7FFF ) to communicate with the Spin
' wrapper.
' 
' These routines allow the cog to inform the Spin wrapper what's going on within itself. In all cases 
' the long[$7FF0] is set with a flag to indicate what internal 'event' is being generated. Then, once
' long[$7FF0] has been cleared, the entire $200 longs of cog are passed to the Spin program a long at 
' a time. This is done by putting the cog value in long[$7FEC] and setting long[$7FF0]. Every time the
' long[$7FF0] is cleared by the Spin wrapper the next long is passed out. After $200 have been passed
' over the code here waits for long[$7FF0] to be cleared again and execution continues. It is up to the
' Spin wrapper to not allow the cog to continue after a 'Stop' or 'NotImplemented' event.
'
' Note that during the copy we load 'dbgTmp' then wrlong that rather than altering the destination of
' the wrlong itself; this is so we can read the SPR's which cannot be used as destination registers. It
' also helps with the counting method used.
'
' In addition, writes to long[$7FF4], long[$7FF8] and long[$7FFC] can be used to pass information back
' to the debugger prior to calling any of the debugging routines. These are displayed on Debug and Stop
' calls. The Spin wrapper dictates how the events are handled and what is displayed.
'
' Example ...
'
'               wrlong  lhs,k_0000_7FF4
'               wrlong  rhs,k_0000_7FF8
'               wrlong  acc,k_0000_7FFC
'               call    #Debug
'
' Note we have to protect the Z flag so we don't screw any Cog code which relies on it being unchanged
' over calls to Debug etc. We do that by using the lsb of the destination register of the Debug_Ret
' which is otherwise unused. It saves a long. We don't need to protect C because we don't use WC in the
' debugger. 

NotImplemented  add    dbgTmp,#1                        ' 4
SingleStep      add    dbgTmp,#1                        ' 3
Stop            add    dbgTmp,#1                        ' 2
Debug           add    dbgTmp,#1                        ' 1

                wrlong  dbgTmp,k_0000_7FF0

                muxnz   Debug_Ret,k_0000_0200           ' Protect Z flag

:Dump           call    #DebugWait
:Src            mov     dbgTmp,$000                     ' No need to pre-initialise this
                wrlong  dbgTmp,k_0000_7FEC
                add     :Src,#1
                and     :Src,#$1FF WZ, NR               ' If we hit $200 we corrupted the opcode
        IF_Z    sub     :Src,k_0000_0200                ' So set it to $000 ...
                wrlong  k_0000_7FF0,k_0000_7FF0
        IF_NZ   jmp     #:Dump                          ' ... and no more to send out

                call    #DebugWait                      ' leaves dbgTmp zeroed on exit

                and     Debug_Ret,k_0000_0200 WZ, NR    ' Restore Z flag
                
NotImplemented_Ret
SingleStep_Ret
Stop_Ret
Debug_Ret       ret

DebugWait       rdlong  dbgTmp,k_0000_7FF0
                tjnz    dbgTmp,#DebugWait
DebugWait_Ret   ret

dbgTmp          long    0

k_0000_7FEC     long    $0000_7FEC
k_0000_7FF0     long    $0000_7FF0
k_0000_7FF4     long    $0000_7FF4
k_0000_7FF8     long    $0000_7FF8
k_0000_7FFC     long    $0000_7FFC

DAT

' *******************************************************************************************************
' *                                                                                                     *
' *             Main JVM Program                                                                        *
' *                                                                                                     *
' *******************************************************************************************************

JVM_Init        mov     sp,PAR
                mov     bp,sp

                mov     pc,k_JemBp_Plus_4
                mov     opc,#Jem_INVOKESTATIC
                jmp     #Dispatch

' .-----------------------------------------------------------------------------------------------------.
' |             Push the result of an arithmetic operation ( in lhs ) to stack and execute next opcode  |
' `-----------------------------------------------------------------------------------------------------'

PushLhsThenFetch

                call    #PushLhs

' .-----------------------------------------------------------------------------------------------------.
' |             Fetch a JVM / JEM Bytcode Opcode and execute it                                         |
' `-----------------------------------------------------------------------------------------------------'

Fetch           call    #SingleStep

                rdbyte  opc,pc
                add     pc,#1

Dispatch        mov     LMM_pc,k_Opc_Dispatch
                jmp     #LMM_AddX_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             Handle branching ( or not as the case may be )                                          |
' `-----------------------------------------------------------------------------------------------------'

Branch          call    #FetchSignedWordLhs
                add     pc,lhs
                sub     pc,#3
                jmp     #Fetch

SkipBranch      add     pc,#2
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             Pointer to the Opcode Dispatch table held as an LMM program                             |
' `-----------------------------------------------------------------------------------------------------'

k_Opc_Dispatch  long    @Opc_Dispatch

' .-----------------------------------------------------------------------------------------------------.
' |             Stack handling                                                                          |
' `-----------------------------------------------------------------------------------------------------'

PopRhsThenLhs   call    #PopRhs
                call    #PopLhs
PopRhsThenLhs_ret
                ret

PopRhs          call    #PopLhs
                mov     rhs,lhs
PopRhs_ret      ret

PopLhs          rdlong  lhs,sp
                add     sp,#4
PopLhs_Ret      ret

PushZero        mov     lhs,#0
PushLhs         add     sp,#4
                wrlong  lhs,sp
PushLhs_ret
PushZero_ret    ret

' .-----------------------------------------------------------------------------------------------------.
' |             
' `-----------------------------------------------------------------------------------------------------'

CmpLhs          call    #PopLhs
                cmps    lhs,#0 WC, WZ, NR
CmpLhs_Ret      ret

CmpLhsWithRhs   call    #PopRhsThenLhs
                cmps    lhs,rhs WC, WZ, NR
CmpLhsWithRhs_Ret
                ret

' .-----------------------------------------------------------------------------------------------------.
' |             Fetch a word from the bytecode into lhs                                                 | 
' `-----------------------------------------------------------------------------------------------------'

FetchWordLhs    rdbyte  lhs,pc
                add     pc,#1
                shl     lhs,#8
                rdbyte  rhs,pc
                add     pc,#1
                or      lhs,rhs
FetchWordLhs_ret
                ret
                
FetchSignedWordLhs
                call    #FetchWordLhs
                shl     lhs,#16
                sar     rhs,#16
FetchSignedWordLhs_ret
                ret
                
' .-----------------------------------------------------------------------------------------------------.
' |             Pass control back to Spin to handle opcodes not implemented as an LMM program yet       |
' `-----------------------------------------------------------------------------------------------------'

HandleWithSpin  call    #NotImplemented

                jmp     #Fetch
                
' .-----------------------------------------------------------------------------------------------------.
' |             Variables used within the JVM                                                           |
' `-----------------------------------------------------------------------------------------------------'

pc              long    0
sp              long    0
bp              long    0

opc             long    0

lhs             long    0
rhs             long    0
acc             long    0

xp              long    0
yp              long    0
signBit         long    0

DAT

' *******************************************************************************************************
' *                                                                                                     *
' *             LMM Interpreter                                                                         *
' *                                                                                                     *
' *******************************************************************************************************

CON
                        '  opcode zcri cccc ddddddddd sssssssss
 LMM                    = %010111_0001_1111_000000000_000000000                 ' jmp #<src>
 LMM_Short_Skp          = %100000_0011_1111_000000000_000000000 - 4             ' add LMM_pc,#<offset-1>*4
 LMM_Short_Fwd          = %100000_0011_1111_000000000_000000000 - 4             ' add LMM_pc,#<offset-1>*4
 LMM_Short_Rev          = %100001_0011_1111_000000000_000000000 + 4             ' sub LMM_pc,#<offset+1>*4

 LMM_IF_A               =             %1110 << 18                               ' IF_BE
 LMM_IF_AE              =             %1100 << 18                               ' IF_B
 LMM_IF_ALWAYS          =             %0000 << 18                               ' IF_NEVER
 LMM_IF_B               =             %0011 << 18                               ' IF_AE
 LMM_IF_BE              =             %0001 << 18                               ' IF_A
 LMM_IF_C               =             %0011 << 18                               ' IF_NC
 LMM_IF_C_AND_NZ        =             %1011 << 18                               ' IF_NC_OR_Z
 LMM_IF_C_AND_Z         =             %0111 << 18                               ' IF_NC_OR_NZ
 LMM_IF_C_EQ_Z          =             %0110 << 18                               ' IF_C_NE_Z
 LMM_IF_C_NE_Z          =             %1001 << 18                               ' IF_C_EQ_Z
 LMM_IF_C_OR_NZ         =             %0010 << 18                               ' IF_NC_AND_Z
 LMM_IF_C_OR_Z          =             %0001 << 18                               ' IF_NC_AND_NZ
 LMM_IF_E               =             %0101 << 18                               ' IF_NE
 LMM_IF_NC              =             %1100 << 18                               ' IF_C
 LMM_IF_NC_AND_NZ       =             %1110 << 18                               ' IF_C_OR_Z
 LMM_IF_NC_AND_Z        =             %1101 << 18                               ' IF_C_OR_NZ
 LMM_IF_NC_OR_NZ        =             %1000 << 18                               ' IF_C_AND_Z
 LMM_IF_NC_OR_Z         =             %0100 << 18                               ' IF_C_AND_NZ
 LMM_IF_NE              =             %1010 << 18                               ' IF_E
 LMM_IF_NEVER           =             %1111 << 18                               ' IF_ALWAYS
 LMM_IF_NZ              =             %1010 << 18                               ' IF_Z
 LMM_IF_NZ_AND_C        =             %1011 << 18                               ' IF_Z_OR_NC
 LMM_IF_NZ_AND_NC       =             %1110 << 18                               ' IF_Z_OR_C
 LMM_IF_NZ_OR_C         =             %0010 << 18                               ' IF_Z_AND_NC
 LMM_IF_NZ_OR_NC        =             %1000 << 18                               ' IF_Z_AND_C
 LMM_IF_Z               =             %0101 << 18                               ' IF_NZ
 LMM_IF_Z_AND_C         =             %0111 << 18                               ' IF_NZ_OR_NC
 LMM_IF_Z_AND_NC        =             %1101 << 18                               ' IF_NZ_OR_C
 LMM_IF_Z_EQ_C          =             %0110 << 18                               ' IF_Z_NE_C
 LMM_IF_Z_NE_C          =             %1001 << 18                               ' IF_Z_EQ_C
 LMM_IF_Z_OR_C          =             %0001 << 18                               ' IF_NZ_AND_NC
 LMM_IF_Z_OR_NC         =             %0100 << 18                               ' IF_NZ_AND_C

DAT

LmmVm           org     $

' .-----------------------------------------------------------------------------------------------------.
' |             LMM Internal registers and constants                                                    |
' `-----------------------------------------------------------------------------------------------------'

k_CogBp_Minus_4 long    $0010-4                         ' Base adjust for @Label to  hub memory address

k_JemBP_Plus_4  long    @JemByteCodeStart+4

k_0000_0200     long    $0000_0200                      ' ---- ---- ---- --dd dddd ddD- ---- ----

LMM_pc          long    0                               ' LMM Program Counter
LMM_sp          long    0                               ' LMM Stack Pointer ( 0 = Internal Stack )

' .-----------------------------------------------------------------------------------------------------.
' |             CONDITIONAL SKIP                        long    LMM | LMM_Bra_Skp ^ LMM_Cond | n << 9   |
' `-----------------------------------------------------------------------------------------------------'

LMM_Bra_Skp

' .-----------------------------------------------------------------------------------------------------.
' |             JMP     #$+longs                        long    LMM | LMM_Bra_Fwd | longs << 9          |
' `-----------------------------------------------------------------------------------------------------'

LMM_Bra_Fwd     mov     LMM_Bra_Neg2,LMM_Bra_Neg1       ' Double negate
                jmp     #LMM_Bra_Xxx

' .-----------------------------------------------------------------------------------------------------.
' |             JMP     #$-longs                        long    LMM | LMM_Bra_Rev | longs << 9          |
' `-----------------------------------------------------------------------------------------------------'

LMM_Bra_Rev     mov     LMM_Bra_Neg2,#0                 ' Single negate
                
LMM_Bra_Xxx     mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:skp
                mov     LMM_Opc1,LMM_Opc2

:Skp            shr     LMM_Opc1,#9
                and     LMM_Opc1,#$1FF
                shl     LMM_Opc1,#2

LMM_Bra_Neg1    neg     LMM_Opc1,LMM_Opc1
LMM_Bra_Neg2    long    0-0

                andn    LMM_pc,#3
                sub     LMM_pc,#4
                add     LMM_pc,LMM_Opc1

                jmp     #LMM_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             JMP     #@Label                         long    LMM | LMM_Jmp                           |
' |                                                     long    @Label                                  |
' `-----------------------------------------------------------------------------------------------------'

LMM_Add4_Jmp    add     LMM_pc,#4

LMM_Jmp         rdlong  LMM_pc,LMM_pc

' .-----------------------------------------------------------------------------------------------------.
' |             LMM Fetch and Execute Loop                                                              |
' `-----------------------------------------------------------------------------------------------------'

LMM_AddX_Fetch  add     LMM_pc,k_cogBp_Minus_4          ' Adjust @Label address to actual hub addresses

LMM_Add4_Fetch  add     LMM_pc,#4

LMM_Fetch       andn    LMM_pc,#3                       ' Ensure correct long alignment

LMM_Loop        rdlong  LMM_Opc1,LMM_pc
                add     LMM_pc,#7
LMM_Opc1        nop

                rdlong  LMM_Opc2,LMM_pc
                add     LMM_pc,#1
LMM_Opc2        nop

                jmp     #LMM_Loop

' .-----------------------------------------------------------------------------------------------------.
' |             LOAD    reg,#longConstant               long    LMM | LMM_Load | reg << 9               |
' |                                                     long    longConstant                            |
' `-----------------------------------------------------------------------------------------------------'

LMM_load        mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:Skp
                mov     LMM_Opc1,LMM_Opc2
:Skp            shr     LMM_Opc1,#9
                movd    :Dst,LMM_Opc1
                nop
:Dst            rdlong   0-0,LMM_pc
                jmp     #LMM_Add4_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             GTI     dreg,sreg                       long    LMM | LMM_Gti | dreg << 9               |
' |             MOV     dreg,[sreg]                     long    sreg                                    |
' `-----------------------------------------------------------------------------------------------------'

LMM_Gti         mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:Skp
                mov     LMM_Opc1,LMM_Opc2
:Skp            shr     LMM_Opc1,#9
                rdlong  acc,LMM_pc
                movs    :Src,acc
                movd    :DstSrc,Lmm_Opc1
:Src            movs    :DstSrc,0-0
                add     LMM_pc,#4
:DstSrc         mov     0-0,0-0
                jmp     #LMM_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             STI     sreg,dreg                       long    LMM | LMM_Sti | sreg << 9               |
' |             MOV     [dreg],sreg                     long    dreg                                    |
' `-----------------------------------------------------------------------------------------------------'

LMM_Sti         mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:Skp
                mov     LMM_Opc1,LMM_Opc2
:Skp            shr     LMM_Opc1,#9
                rdlong  acc,LMM_pc
                movd    :Src,acc
                movs    :DstSrc,LMM_Opc1
:Src            movd    :DstSrc,0-0
                add     LMM_pc,#4
:DstSrc         mov     0-0,0-0
                jmp     #LMM_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             EXECUTE reg                             long    LMM | LMM_Execute | reg << 9            |
' `-----------------------------------------------------------------------------------------------------'

LMM_Execute     mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:Skp
                mov     LMM_Opc1,LMM_Opc2
:Skp            shr     LMM_Opc1,#9
                movs    :Src,LMM_Opc1
                nop
:Src            mov     :Opc,0-0
                nop
:Opc            long    0-0
                jmp     #LMM_Fetch
                
' .-----------------------------------------------------------------------------------------------------.
' |             JMP     reg                             long    LMM | LMM_Jmp_Reg | reg << 9            |
' `-----------------------------------------------------------------------------------------------------'

LMM_Jmp_Reg     mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:Skp
                mov     LMM_Opc1,LMM_Opc2
:Skp            shr     LMM_Opc1,#9
                movs    :Src,LMM_Opc1
                nop
:Src            mov     LMM_pc,0-0
                jmp     #LMM_AddX_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             CASE     reg                            long    LMM | LMM_Case | reg << 9               |
' |                                                     word    @Label0                                 |
' |                                                     word    @Label1                                 |
' |                                                     :                                               |
' |                                                     word    @LabelN                                 |
' `-----------------------------------------------------------------------------------------------------'

LMM_Case        mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:Skp
                mov     LMM_Opc1,LMM_Opc2
:Skp            shr     LMM_Opc1,#9

                movs    :Src1,LMM_Opc1
                movs    :Src2,LMM_Opc1
                andn    LMM_pc,#3                       ' Ensure pc is aligned correctly
:Src1           add     LMM_pc,0-0
:Src2           add     LMM_pc,0-0

                rdword  LMM_pc,LMM_pc
                jmp     #LMM_AddX_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             CALL    #@Label                         long    LMM | LMM_Call                          |
' |                                                     long    @Label                                  |
' `-----------------------------------------------------------------------------------------------------'

LMM_Call        tjz     LMM_sp,#LMM_Call_Int            ' Use internal stack if sp == 0

                wrword  LMM_pc,LMM_sp                   ' Push to external stack
                add     LMM_sp,#2
                jmp     #LMM_Jmp
                
LMM_Call_Int    mov     $1EF,LMM_pc                     ' Push to internal stack
                sub     LMM_Call_Int,k_0000_0200        ' Adjust push address
                sub     LMM_Ret_Int,#1                  ' Adjust pop address
                jmp     #LMM_Jmp

' .-----------------------------------------------------------------------------------------------------.
' |             RET                                     long    LMM | LMM_Ret                           |
' `-----------------------------------------------------------------------------------------------------'

LMM_Ret         tjz     LMM_sp,#LMM_Ret_Int             ' Use internal stack if sp == 0

                sub     LMM_sp,#2                       ' Pop from external stack
                rdword  LMM_pc,LMM_sp
                jmp     #LMM_Add4_Fetch
                                                        
LMM_Ret_Int     mov     LMM_pc,$1F0                     ' Pop from internal stack
                add     LMM_Call_Int,k_0000_0200        ' Adjust push address
                add     LMM_Ret_Int,#1                  ' Adjust pop address
                jmp     #LMM_Add4_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             DJNZ    reg,#@Label                     long    LMM | LMM_Djnz | reg << 9               |
' |                                                     long    @Label                                  |
' `-----------------------------------------------------------------------------------------------------'

LMM_Djnz        movi    LMM_Djnz_OpcDst,#%111001_00_1   ' Djnz opcode

LMM_Djnz_Xxx    mov     acc,LMM_pc
                and     acc,#1
                tjnz    acc,#:Skp
                mov     LMM_Opc1,LMM_Opc2
:Skp            shr     LMM_Opc1,#9
                movd    LMM_Djnz_OpcDst,LMM_Opc1
                nop     
LMM_Djnz_OpcDst djnz    0-0,#LMM_Jmp
                jmp     #LMM_Add4_Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             TJZ     reg,#@Label                     long    LMM | LMM_Tjz | reg << 9                |
' |                                                     long    @Label                                  |
' `-----------------------------------------------------------------------------------------------------'

LMM_Tjz         movi    LMM_Djnz_OpcDst,#%111011_00_0   ' Tjz opcode
                jmp     #LMM_Djnz_Xxx

' .-----------------------------------------------------------------------------------------------------.
' |             TJNZ    reg,#@Label                     long    LMM | LMM_Tjnz | reg << 9               |
' |                                                     long    @Label                                  |
' `-----------------------------------------------------------------------------------------------------'

LMM_Tjnz        movi    LMM_Djnz_OpcDst,#%111010_00_0   ' Tjnz Opcode
                jmp     #LMM_Djnz_Xxx

' *******************************************************************************************************
' *                                                                                                     *
' *             End of LMM Interpreter                                                                  *
' *                                                                                                     *
' *******************************************************************************************************

DAT

' *******************************************************************************************************
' *                                                                                                     *
' *             Place LMM Program Variables / Registers / Global Constants / Fast Subroutines here      *
' *                                                                                                     *
' *******************************************************************************************************

                fit     $1F0                            ' Ensure we do not exceed Cog maximum

DAT

' *******************************************************************************************************
' *                                                                                                     *
' *             Place LMM Program here                                                                  *
' *                                                                                                     *
' *******************************************************************************************************

LmmCodeStart

' .-----------------------------------------------------------------------------------------------------.
' |             Opcode dispatch                                                                         |
' `-----------------------------------------------------------------------------------------------------'

Opc_Dispatch    long    LMM | LMM_Case | opc << 9

                word    @Opc_NOP                        ' $00
                word    @Opc_ICONST_M1                  ' $01
                word    @Opc_ICONST_0                   ' $02
                word    @Opc_ICONST_1                   ' $03
                word    @Opc_ICONST_2                   ' $04
                word    @Opc_ICONST_3                   ' $05
                word    @Opc_ICONST_4                   ' $06
                word    @Opc_ICONST_5                   ' $07
                word    @Opc_BIPUSH                     ' $08
                word    @Opc_SIPUSH                     ' $09
                word    @Opc_ILOAD                      ' $0A
                word    @Opc_ILOAD_0                    ' $0B
                word    @Opc_ILOAD_1                    ' $0C
                word    @Opc_ILOAD_2                    ' $0D
                word    @Opc_ILOAD_3                    ' $0E
                word    @Opc_ISTORE                     ' $0F
                word    @Opc_ISTORE_0                   ' $10
                word    @Opc_ISTORE_1                   ' $11
                word    @Opc_ISTORE_2                   ' $12
                word    @Opc_ISTORE_3                   ' $13
                word    @Opc_IFEQ                       ' $14
                word    @Opc_IFNE                       ' $15
                word    @Opc_IFLT                       ' $16
                word    @Opc_IFLE                       ' $17
                word    @Opc_IFGT                       ' $18
                word    @Opc_IFGE                       ' $19
                word    @Opc_IF_ICMPEQ                  ' $1A
                word    @Opc_IF_ICMPNE                  ' $1B
                word    @Opc_IF_ICMPLT                  ' $1C
                word    @Opc_IF_ICMPGE                  ' $1D
                word    @Opc_IF_ICMPGT                  ' $1E
                word    @Opc_IF_ICMPLE                  ' $1F
                word    @Opc_IF_ACMPEQ                  ' $20
                word    @Opc_IF_ACMPNE                  ' $21
                word    @Opc_IRETURN                    ' $22
                word    @Opc_RETURN                     ' $23
                word    @Opc_INVOKEVIRTUAL              ' $24
                word    @Opc_INVOKESTATIC               ' $25
                word    @Opc_GETSTATIC                  ' $26
                word    @Opc_PUTSTATIC                  ' $27
                word    @Opc_POP                        ' $28
                word    @Opc_POP2                       ' $29
                word    @Opc_DUP                        ' $2A
                word    @Opc_DUP_X1                     ' $2B
                word    @Opc_DUP_X2                     ' $2C
                word    @Opc_DUP2                       ' $2D
                word    @Opc_DUP2_X1                    ' $2E
                word    @Opc_DUP2_X2                    ' $2F
                word    @Opc_SWAP                       ' $30
                word    @Opc_IADD                       ' $31
                word    @Opc_ISUB                       ' $32
                word    @Opc_INEG                       ' $33
                word    @Opc_IOR                        ' $34
                word    @Opc_ISHL                       ' $35
                word    @Opc_ISHR                       ' $36
                word    @Opc_IUSHR                      ' $37
                word    @Opc_IAND                       ' $38
                word    @Opc_IXOR                       ' $39
                word    @Opc_I2B                        ' $3A
                word    @Opc_GOTO                       ' $3B
                word    @Opc_INVOKEINTERFACE            ' $3C
                word    @Opc_ARRAYLENGTH                ' $3D
                word    @Opc_ATHROW                     ' $3E
                word    @Opc_CHECKCAST                  ' $3F
                word    @Opc_INSTANCEOF                 ' $40
                word    @Opc_WIDE                       ' $41
                word    @Opc_IINC                       ' $42
                word    @Opc_GETFIELD                   ' $43
                word    @Opc_PUTFIELD                   ' $44
                word    @Opc_NEW                        ' $45
                word    @Opc_NEWARRAY                   ' $46
                word    @Opc_ANEWARRAY                  ' $47
                word    @Opc_IALOAD                     ' $48
                word    @Opc_IASTORE                    ' $49
                word    @Opc_BALOAD                     ' $4A
                word    @Opc_BASTORE                    ' $4B
                word    @Opc_LDC                        ' $4C
                word    @Opc_LDC_W                      ' $4D
                word    @Opc_LDC2_W                     ' $4E
                word    @Opc_IMUL                       ' $4F
                word    @Opc_IDIV                       ' $50
                word    @Opc_IREM                       ' $51
                word    @Opc_JSR                        ' $52
                word    @Opc_RET                        ' $53
                word    @Opc_TABLESWITCH                ' $54
                word    @Opc_LOOKUPSWITCH               ' $55

' .-----------------------------------------------------------------------------------------------------.
' |             NOP                                                                                 $00 |
' |             Meaning: Do nothing.                                                                    |
' `-----------------------------------------------------------------------------------------------------'

Opc_NOP         jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             ICONST_M1                                                                           $01 |
' |             Meaning: Push the integer constant -1.                                                  |
' |             Description: This bytecode pushes the integer constant -1 onto the stack.               |
' |-----------------------------------------------------------------------------------------------------|
' |             ICONST_0                                                                        $02-$07 |
' |             Meaning: Push the integer constant <C>.                                                 |
' |             Description: This bytecode pushes an integer constant onto the stack. There             |
' |             are six associated bytecodes, one for each of the integers 0-5: iconst_0,               |
' |             iconst_1, iconst_2, iconst_3, iconst_4, and iconst_5.                                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_ICONST_M1
Opc_ICONST_0
Opc_ICONST_1
Opc_ICONST_2
Opc_ICONST_3
Opc_ICONST_4
Opc_ICONST_5    mov     lhs,opc
                sub     lhs,#Jem_ICONST_0
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             BIPUSH                                                                              $08 |
' |             Meaning: Push a 1-byte signed integer.                                                  |
' |             Description: The first byte following the opcode, byte1, is interpreted as a            |
' |             signed 8-bit value. This value is expanded to a 32-bit integer and pushed onto          |
' |             the operand stack.                                                                      |
' `-----------------------------------------------------------------------------------------------------'

Opc_BIPUSH      rdbyte  lhs,pc
                add     pc,#1
                shl     lhs,#24
                sar     lhs,#24
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             SIPUSH                                                                              $09 |
' |             Meaning: Push a 2-byte signed integer.                                                  |
' |             Description: The first and second byte following the opcode, byte1 and byte2,           |
' |             are assembled into a signed 16-bit value. This value is expanded to a 32-bit            |
' |             integer and pushed onto the operand stack.                                              |
' `-----------------------------------------------------------------------------------------------------'

Opc_SIPUSH      call    #FetchSignedWordLhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ILOAD                                                                               $0A |
' |             Meaning: Load integer from local variable.                                              |
' |             Description: The value of the local variable in the current Java frame is               |
' |             pushed onto the operand stack. This value must be of type integer.                      |
' |-----------------------------------------------------------------------------------------------------|
' |             ILOAD_0                                                                             $0B |
' |             ILOAD_1                                                                             $0C |
' |             ILOAD_2                                                                             $0D |
' |             ILOAD_3                                                                             $0E |
' |             Meaning: Load integer from local variable with specific index.                          |
' |             Description: The value of the local variable <l> in the current Java frame is           |
' |             pushed onto the operand stack.                                                          |
' |             This value must be of type integer. There are four of these bytecodes, one for          |
' |             each of the integers 0-3: iload_0, iload_1, iload_2, and iload_3.                       |
' `-----------------------------------------------------------------------------------------------------'

Opc_ILOAD       rdbyte  opc,pc
                add     pc,#1
                add     opc,#Jem_ILOAD_0

Opc_ILOAD_0
Opc_ILOAD_1
Opc_ILOAD_2
Opc_ILOAD_3     sub     opc,#Jem_ILOAD_0
                shl     opc,#2
                add     opc,bp
                rdlong  lhs,opc
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ISTORE                                                                              $0F |
' |             Meaning: Store integer into local variable.                                             |
' |             Description: Local variable in the current Java frame is set to a value. This           |
' |             value must be an integer.                                                               |
' |-----------------------------------------------------------------------------------------------------|
' |             ISTORE_0                                                                            $10 |
' |             ISTORE_1                                                                            $11 |
' |             ISTORE_2                                                                            $12 |
' |             ISTORE_3                                                                            $13 |
' |             Meaning: Store integer into local variable with specific index.                         |
' |             Description: Local variable <l> in the current Java frame is set to a value.            |
' |             This value must be an integer. There are four of these bytecodes, one for each          |
' |             of the integers 0-3: istore_0, istore_1, istore_2, and istore_3.                        |
' `-----------------------------------------------------------------------------------------------------'


Opc_ISTORE      rdbyte  opc,pc
                add     pc,#1
                add     opc,#Jem_ISTORE_0

Opc_ISTORE_0
Opc_ISTORE_1
Opc_ISTORE_2
Opc_ISTORE_3    sub     opc,#Jem_ILOAD_0
                shl     opc,#2
                add     opc,bp
                wrlong  lhs,opc
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             IFEQ                                                                                $14 |
' |             Meaning: Branch if equal.                                                               |
' `-----------------------------------------------------------------------------------------------------'

Opc_IFEQ        call    #CmpLhs
        IF_E    jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IFNE                                                                                $15 |
' |             Meaning: Branch if not equal.                                                           |
' `-----------------------------------------------------------------------------------------------------'

Opc_IFNE        call    #CmpLhs
        IF_NE   jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IFLT                                                                                $16 |
' |             Meaning: Branch if less than.                                                           |
' `-----------------------------------------------------------------------------------------------------'

Opc_IFLT        call    #CmpLhs
        IF_B    jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IFLE                                                                                $17 |
' |             Meaning: Branch if less than or equal.                                                  |
' `-----------------------------------------------------------------------------------------------------'

Opc_IFLE        call    #CmpLhs
        IF_BE   jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IFGT                                                                                $18 |
' |             Meaning: Branch if greater than.                                                        |
' `-----------------------------------------------------------------------------------------------------'

Opc_IFGT        call    #CmpLhs
        IF_A    jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IFGE                                                                                $19 |
' |             Meaning: Branch if greater than or equal.                                               |
' `-----------------------------------------------------------------------------------------------------'

Opc_IFGE        call    #CmpLhs
        IF_AE   jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ICMPEQ                                                                           $1A |
' |             Meaning: Branch if integers v1 and v2 are equal.                                        |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ICMPEQ   call    #CmpLhsWithRhs
        IF_E    jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ICMPNE                                                                           $1B |
' |             Meaning: Branch if integers v1 and v2 are not equal.                                    |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ICMPNE   call    #CmpLhsWithRhs
        IF_NE   jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ICMPLT                                                                           $1C |
' |             Meaning: Branch if integer v1 is less than integer v2.                                  |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ICMPLT   call    #CmpLhsWithRhs
        IF_B    jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ICMPGE                                                                           $1D |
' |             Meaning: Branch if integer v1 greater than or equal to integer v2.                      |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ICMPGE   call    #CmpLhsWithRhs
        IF_AE   jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ICMPGT                                                                           $1E |
' |             Meaning: Branch if integer v1 is greater than integer v2.                               |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ICMPGT   call    #CmpLhsWithRhs
        IF_A    jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ICMPLE                                                                           $1F |
' |             Meaning: Branch if integer v1 less than or equal to integer v2.                         |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ICMPLE   call    #CmpLhsWithRhs
        IF_BE   jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ACMPEQ                                                                           $20 |
' |             Meaning: Branch if object references equal.                                             |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ACMPEQ
                jmp     #HandleWithSpin
        IF_E    jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IF_ACMPNE                                                                           $21 |
' |             Meaning: Branch if object references not equal.                                         |
' `-----------------------------------------------------------------------------------------------------'

Opc_IF_ACMPNE
                jmp     #HandleWithSpin
        IF_NE   jmp     #Branch
                jmp     #SkipBranch

' .-----------------------------------------------------------------------------------------------------.
' |             IRETURN                                                                             $22 |
' |             Meaning: Return integer from function.                                                  |
' `-----------------------------------------------------------------------------------------------------'

Opc_IRETURN     call    #PopLhs
                sub     bp,#4
                rdlong  pc,bp
                sub     bp,#4
                rdlong  sp,bp
                sub     bp,#4
                rdlong  bp,bp
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             RETURN                                                                              $23 |
' |             Meaning: Return (void) from method.                                                     |
' `-----------------------------------------------------------------------------------------------------'

Opc_RETURN      sub     bp,#4
                rdlong  pc,bp
                sub     bp,#4
                rdlong  sp,bp
                sub     bp,#4
                rdlong  bp,bp
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             INVOKEVIRTUAL                                                                       $24 |
' |             Meaning: Invoke method based on runtime type.                                           |
' `-----------------------------------------------------------------------------------------------------'

Opc_INVOKEVIRTUAL
                jmp     #HandleWithSpin
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             INVOKESTATIC                                                                        $25 |
' |             Meaning: Invoke a class (static) method.                                                |
' `-----------------------------------------------------------------------------------------------------'

'               SP -->
'       .----.        .----.          .----.          .----.
'       | A  |        |    |          | BP |          | BP |
'       |----|        |----|          |----|          |----|
' SP -->| B  |        |    |          | SP |          | SP |
'       `----'        |----|          |----|          |----|
'                     |    |          | PC |          | PC |
'                     |----|          |----|          |----|
'                     | A  |    BP -->| A  |    BP -->| A  |
'                     |----|          |----|          |----|
'               XP -->| B  |    SP -->| B  |          | B  |
'                     `----'          `----'          |----|
'                                                     | 0  |
'                                                     |----|
'                                               SP -->| 0  |
'                                                     `----'

'  xp := sp + 3*4
'  sp := sp - params*4
'  copy parms x [xp] := [xp-3*4]
'  push bp,sp,pc      
'  bp := sp+1*4
'  sp := xp
'  push locals x 0

Opc_INVOKESTATIC         

                call    #FetchWordLhs           ' Adr of method table
                add     lhs,k_JemBp_Plus_4
                add     lhs,k_CogBp_Minus_4
                
                rdbyte  acc,lhs                 ' How many parameters

                mov     xp,sp                   ' xp := sp + 3*4
                add     xp,#3*4
                      
                sub     sp,acc                  '  sp := sp - params*4
                add     sp,acc
                
                shr     acc,#1

                long    LMM | LMM_Tjz | acc << 9
                long    @Opc_INVOKESTATIC_P_None
                              
                mov     yp,xp

Opc_INVOKESTATIC_P_Loop

                sub     yp,#3*4
                rdlong  rhs,yp
                add     yp,#3*4
                wrlong  rhs,yp
        
                sub     yp,#4
                
                long    LMM | LMM_Djnz | acc << 9
                long    @Opc_INVOKESTATIC_P_Loop

Opc_INVOKESTATIC_P_None
                         
                mov     yp,sp
                add     yp,#4
                wrlong  bp,yp
                add     yp,#4
                wrlong  sp,yp
                add     yp,#4
                wrlong  pc,yp   
                
                add     yp,#4
                mov     bp,yp
                
                mov     sp,xp

                add     lhs,#1                  ' How many locals
                rdbyte  acc,lhs

                add     sp,acc
                add     sp,acc

                add     lhs,#1                  ' Flags ( native ? )
                rdbyte  acc,lhs

                long    LMM | LMM_Tjz | acc << 9
                long    @Opc_INVOKESTATIC_Native
                                   
                add     lhs,#1                  ' Adr of method
                mov     pc,lhs
                call    #FetchWordLhs
                mov     pc,lhs
                add     pc,k_JemBp_Plus_4

                jmp     #Fetch
                                                
Opc_INVOKESTATIC_Native
                
                long    LMM | LMM_Jmp
                long    @Opc_RETURN

' .-----------------------------------------------------------------------------------------------------.
' |             GETSTATIC                                                                           $26 |
' |             Meaning: Get 16bit static field from class.                                             |
' `-----------------------------------------------------------------------------------------------------'

Opc_GETSTATIC
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             PUTSTATIC                                                                           $27 |
' |             Meaning: Set 16bit static field in class.                                               |
' `-----------------------------------------------------------------------------------------------------'

Opc_PUTSTATIC
                jmp     #HandleWithSpin
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             POP                                                                                 $28 |
' |             Meaning: Pop the top word from the stack.                                               |
' `-----------------------------------------------------------------------------------------------------'

Opc_POP         Call    #PopLhs
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             POP2                                                                                $29 |
' |             Meaning: Pop the top two words from the stack.                                          |
' `-----------------------------------------------------------------------------------------------------'

Opc_POP2        call    #PopRhsThenLhs
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             DUP                                                                                 $2A |
' |             Meaning: Duplicate the top word on the stack.                                           |
' `-----------------------------------------------------------------------------------------------------'

Opc_DUP         rdlong  lhs,sp
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             DUP_X1                                                                              $2B |
' |             Meaning: Duplicate the top word on the stack and insert a copy two words down           |
' |             in the stack.                                                                           |
' `-----------------------------------------------------------------------------------------------------'

Opc_DUP_X1
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             DUP_X2                                                                              $2C |
' |             Meaning: Duplicate the top word on the stack and insert the copy three words            |
' |             down in the stack.                                                                      |
' `-----------------------------------------------------------------------------------------------------'

Opc_DUP_X2
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             DUP2                                                                                $2D |
' |             Meaning: Duplicate the top two words on the stack.                                      |
' `-----------------------------------------------------------------------------------------------------'

Opc_DUP2        rdlong  rhs,sp
                sub     sp,#4
                rdlong  lhs,sp
                add     sp,#8
                wrlong  rhs,sp
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             DUP2_X1                                                                             $2E |
' |             Meaning: Duplicate the top two words on the stack and insert the copies two             |
' |             words down in the stack.                                                                |
' `-----------------------------------------------------------------------------------------------------'

Opc_DUP2_X1
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             DUP2_X2                                                                             $2F |
' |             Meaning: Duplicate the top two words on the stack and insert the copies three           |
' |             words down in the stack.                                                                |
' `-----------------------------------------------------------------------------------------------------'

Opc_DUP2_X2
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             SWAP                                                                                $30 |
' |             Meaning: Swap the top two elements on the stack.                                        |
' `-----------------------------------------------------------------------------------------------------'

Opc_SWAP        call    #PopRhs
                rdlong  lhs,sp
                wrlong  rhs,sp
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IADD                                                                                $31 |
' |             Meaning: Integer add.                                                                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_IADD        call    #PopRhsThenLhs
                adds    lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ISUB                                                                                $32 |
' |             Meaning: Integer subtract.                                                              |
' `-----------------------------------------------------------------------------------------------------'

Opc_ISUB        call    #PopRhsThenLhs
                subs    lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             INEG                                                                                $33 |
' |             Meaning: Integer negate.                                                                |
' `-----------------------------------------------------------------------------------------------------'

Opc_INEG        call    #PopLhs
                neg     lhs,lhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IOR                                                                                 $34 |
' |             Meaning: Integer boolean OR.                                                            |
' `-----------------------------------------------------------------------------------------------------'

Opc_IOR         call    #PopRhsThenLhs
                or      lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ISHL                                                                                $35 |
' |             Meaning: Integer shift left.                                                            |
' `-----------------------------------------------------------------------------------------------------'

Opc_ISHL        call    #PopRhsThenLhs
                shl     lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ISHR                                                                                $36 |
' |             Meaning: Integer arithmetic shift right.                                                |
' `-----------------------------------------------------------------------------------------------------'

Opc_ISHR        call    #PopRhsThenLhs
                sar     lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IUSHR                                                                               $37 |
' |             Meaning: Integer logical shift right.                                                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_IUSHR       call    #PopRhsThenLhs
                shr     lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IAND                                                                                $38 |
' |             Meaning: Integer boolean AND.                                                           |
' `-----------------------------------------------------------------------------------------------------'

Opc_IAND        call    #PopRhsThenLhs
                and     lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IXOR                                                                                $39 |
' |             Meaning: Integer boolean XOR.                                                           |
' `-----------------------------------------------------------------------------------------------------'

Opc_IXOR        call    #PopRhsThenLhs
                xor     lhs,rhs
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             I2B                                                                                 $3A |
' |             Meaning: Integer to signed byte.                                                        |
' `-----------------------------------------------------------------------------------------------------'

Opc_I2B         jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             GOTO                                                                                $3B |
' |             Meaning: Branch.                                                                        |
' |             Description: Execution proceeds at the signed 16-bit offset from the address            |
' |             of this instruction. The offset is constructed from byte1 and byte2.                    |
' `-----------------------------------------------------------------------------------------------------'

Opc_GOTO        jmp     #Branch

' .-----------------------------------------------------------------------------------------------------.
' |             INVOKEINTERFACE                                                                     $3C |
' |             Meaning: Invoke interface method.                                                       |
' |             Note                                                                                    |
' |             Unlike invokevirtual and invokespecial, the method block does not indicate the          |
' |             number of available arguments. This number is taken from the bytecode.                  |
' `-----------------------------------------------------------------------------------------------------'

Opc_INVOKEINTERFACE
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ARRAYLENGTH                                                                         $3D |
' |             Meaning: Get length of array.                                                           |
' |             Description: The length of the array is determined and replaces aref on the             |
' |             top of the stack. The aref must be a reference to an array object.                      |
' |             Note                                                                                    |
' |             A NullPointerException is thrown if the aref is null.                                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_ARRAYLENGTH
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ATHROW                                                                              $3E |
' |             Meaning: Throw exception or error.                                                      |
' `-----------------------------------------------------------------------------------------------------'

Opc_ATHROW
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             CHECKCAST                                                                           $3F |
' |             Meaning: Make sure object is of given type.                                             |
' |             Description: Determines whether the referenced object can be cast to be a               |
' |             reference to an object of another class. A null object reference can be cast to         |
' |             any class. Otherwise, the referenced object must be an instance of the expected         |
' |             class or one of its superclasses. byte1 and byte2 are used to construct an              |
' |             index into the constant pool of the current class, which is presumed to be a            |
' |             class name that can be resolved to a class pointer.                                     |
' |             Note                                                                                    |
' |             A ClassCastException is thrown if the referenced object cannot be cast to the           |
' |             expected class.                                                                         |
' `-----------------------------------------------------------------------------------------------------'

Opc_CHECKCAST
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             INSTANCEOF                                                                          $40 |
' |             Meaning: Determine if an object is of given type and return result.                     |
' |             Description: Determines whether the referenced object can be cast to be a               |
' |             reference to an object of the expected class. This instruction will overwrite           |
' |             the object reference with 1 if the object is an instance of the expected class          |
' |             or one of its superclasses. Otherwise, the object reference is overwritten by 0.        |
' `-----------------------------------------------------------------------------------------------------'

Opc_INSTANCEOF
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             WIDE                                                                                $41 |
' `-----------------------------------------------------------------------------------------------------'

Opc_WIDE
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IINC                                                                                $42 |
' |             Meaning: Increment local variable by constant.                                          |
' |             Description: Local variable at byte1 in the current Java frame must contain an          |
' |             integer. Its value is incremented by the value byte2, where byte2 is treated as         |
' |             a signed 8-bit quantity.                                                                |
' `-----------------------------------------------------------------------------------------------------'

Opc_IINC        rdbyte  opc,pc
                add     pc,#1
                shl     opc,#2
                add     opc,bp
                rdlong  lhs,opc

                rdbyte  rhs,pc
                add     pc,#1
                shl     rhs,#24
                sar     rhs,#24

                adds    lhs,rhs

                wrlong  lhs,opc

                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             GETFIELD                                                                            $43 |
' |             Meaning: Get 16bit field from object.                                                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_GETFIELD
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             PUTFIELD                                                                            $44 |
' |             Meaning: Set 16bit field in object.                                                     |
' `-----------------------------------------------------------------------------------------------------'

Opc_PUTFIELD
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             NEW                                                                                 $45 |
' |             Meaning: Create new object.                                                             |
' |             Description: byte1 and byte2 are used to construct an index into the constant           |
' |             pool of the current class, which must be a class name that can be resolved to a         |
' |             class pointer. A new instance of that class is then created, and a reference to         |
' |             the object is pushed on the stack.                                                      |
' `-----------------------------------------------------------------------------------------------------'

Opc_NEW
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             NEWARRAY                                                                            $46 |
' |             Meaning: Allocate new array.                                                            |
' |             Description: A new array of a specific array type, capable of holding size              |
' |             elements, is allocated. The result is a reference to the new object. Allocation         |
' |             of an array large enough to contain size items of the specific array type is            |
' |             attempted and all elements of the array are initialized to 0.                           |
' |             size represents the number of elements in the new array and must be an                  |
' |             integer. The result is stored with an internal code that indicates the type of          |
' |             array to allocate. Possible values for the type of array are as follows:                |
' |             T_BOOLEAN(4), T_chAR(5), T_FLOAT(6), T_DOUBLE(7), T_BYTE(8), T_SHORT(9),                |
' |             T_INT(10), and T_LONG(11).                                                              |
' |             Note                                                                                    |
' |             A NegativeArraySizeException is thrown if size is less than 0. An                       |
' |             OutOfMemoryError is thrown if there is not enough memory to allocate the array.         |
' `-----------------------------------------------------------------------------------------------------'

Opc_NEWARRAY
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             ANEWARRAY                                                                           $47 |
' |             Meaning: Allocate new array of objects.                                                 |
' |             Description: A new array of the indicated class type and capable of holding             |
' |             size elements is allocated. The result is a reference to the new object.                |
' |             Allocation of an array large enough to contain size elements of the given class         |
' |             type is attempted and all elements of the array are initialized to null.                |
' |             size represents the number of elements in the new array and must be an                  |
' |             integer. byte1 and byte2 are used to construct an index into the constant pool          |
' |             of the current class. When the item at that index is resolved, the resulting            |
' |             entry must be a class.                                                                  |
' |             The anewarray instruction is used to create a single-dimension array.                   |
' |             Note                                                                                    |
' |             A NegativeArraySizeException is thrown if size is less than 0. An                       |
' |             OutOfMemoryError is thrown if there is not enough memory to allocate the array.         |
' `-----------------------------------------------------------------------------------------------------'

Opc_ANEWARRAY
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IALOAD                                                                              $48 |
' |             Meaning: Load integer from array.                                                       |
' |             Description: The integer value at the array index is retrieved and pushed onto          |
' |             the top of the stack. The aref must be a reference to an array of integers;             |
' |             likewise, the index into the array must be an integer.                                  |
' |             Note                                                                                    |
' |             A NullPointerException is thrown if aref is null. An                                    |
' |             ArrayIndexOutOfBoundsException is thrown if the array index is not within the           |
' |             bounds of the array.                                                                    |
' `-----------------------------------------------------------------------------------------------------'

Opc_IALOAD
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IASTORE                                                                             $49 |
' |             Meaning: Store into integer array.                                                      |
' |             Description: An integer value is popped off the stack and stored in the array           |
' |             at the index. The aref must be a reference to an array of integer values, and           |
' |             the index into the array must be an integer as well.                                    |
' `-----------------------------------------------------------------------------------------------------'

Opc_IASTORE
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             BALOAD                                                                              $4A |
' |             Meaning: Load signed byte from array.                                                   |
' |             Description: The signed byte value at the array index is retrieved, expanded            |
' |             to an integer, and pushed onto the top of the stack. The aref must be a                 |
' |             reference to an array of signed byte values, and the index into the array must          |
' |             be an integer.                                                                          |
' `-----------------------------------------------------------------------------------------------------'

Opc_BALOAD
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             BASTORE                                                                             $4B |
' |             Meaning: Store into signed byte array.                                                  |
' |             Description: An integer is popped off the stack, converted to a signed byte,            |
' |             and stored in the array at the index. The arrayref must be a reference to an            |
' |             array of signed bytes, and the index into the array must be an integer. If the          |
' |             integer value is too large to be a signed byte, it is truncated.                        |
' `-----------------------------------------------------------------------------------------------------'

Opc_BASTORE
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             LDC                                                                                 $4C |
' |             Meaning: Push item from constant pool.                                                  |
' |             Description: byte1 is used as an unsigned 8-bit index into the constant pool            |
' |             of the current class. After the item at that index is resolved, it is pushed            |
' |             onto the stack.                                                                         |
' |             Note                                                                                    |
' |             This bytecode instruction throws an OutOfMemoryError if a String object is              |
' |             being pushed and there is not enough memory to allocate space for it.                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_LDC
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             LDC_W                                                                               $4D |
' |             Meaning: Push 2-byte item from constant pool.                                           |
' |             Description: byte1 and byte2 are used to construct an unsigned 16-bit index             |
' |             into the constant pool of the current class. After the item at that index is            |
' |             resolved, it is pushed onto the stack.                                                  |
' |             Note                                                                                    |
' |             This bytecode instruction throws an OutOfMemoryError if a String object is              |
' |             being pushed and there is not enough memory to allocate space for it.                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_LDC_W
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             LDC2_W                                                                              $4E |
' |             Meaning: Push long or double from constant pool.                                        |
' |             Description: byte1 and byte2 are used to construct an unsigned 16-bit index             |
' |             into the constant pool of the current class. After the two-word constant at             |
' |             that index is resolved, it is pushed onto the stack.                                    |
' |             Note                                                                                    |
' |             This bytecode instruction throws an OutOfMemoryError if a String object is              |
' |             being pushed and there is not enough memory to allocate space for it.                   |
' `-----------------------------------------------------------------------------------------------------'

Opc_LDC2_W
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IMUL                                                                                $4F |
' |             Meaning: Integer multiply.                                                              |
' `-----------------------------------------------------------------------------------------------------'

Opc_IMUL        call    #PopRhsThenLhs
                mov     acc,#0 
                          
                neg     lhs,lhs WC
                muxc    signBit,#1

                neg     rhs,rhs WC
        IF_C    xor     signBit,#1

Opc_IMUL_Loop   shr     rhs,#1 WC
     
        IF_C    add     acc,lhs

                shl     lhs,#1

                long    LMM | LMM_Tjnz | rhs << 9
                long    @Opc_IMUL_Loop

                mov     lhs,acc

                shr     signBit,#1 WC
        IF_C    neg     lhs,lhs

                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IDIV                                                                                $50 |
' |             Meaning: Integer divide.                                                                |
' `-----------------------------------------------------------------------------------------------------'

Opc_IDIV
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             IREM                                                                                $51 |
' |             Meaning: Integer remainder.                                                             |
' `-----------------------------------------------------------------------------------------------------'

Opc_IREM
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             JSR                                                                                 $52 |
' |             Meaning: Jump subroutine.                                                               |
' |             Description: Execution proceeds at the signed 16-bit offset from the address            |
' |             of this instruction. The offset is constructed from byte1 and byte2. The                |
' |             address of the instruction immediately following the current instruction is             |
' |             pushed onto the stack to provide a return address from the subroutine.                  |
' `-----------------------------------------------------------------------------------------------------'

Opc_JSR         mov     lhs,pc
                call    #PushLhs
                jmp     #Branch

' .-----------------------------------------------------------------------------------------------------.
' |             RET                                                                                 $53 |
' |             Meaning: Return from subroutine.                                                        |
' |             Description: Local variable in the current Java frame must contain a return             |
' |             address. The contents of the local variable are written into the program                |
' |             counter.                                                                                |
' `-----------------------------------------------------------------------------------------------------'

Opc_RET         rdbyte  opc,pc
                add     pc,#1
                shl     opc,#2
                add     opc,bp
                rdlong  pc,opc
                jmp     #Fetch

' .-----------------------------------------------------------------------------------------------------.
' |             TABLESWITCH                                                                         $54 |
' |             Meaning: Access jump table by index and jump.                                           |
' |             Description: Immediately after the tableswitch instruction, padding consisting          |
' |             of 0-3 zeros is inserted so that the next byte begins at an address that is a           |
' |             multiple of four. A series of offsets follows the padding. These offsets are            |
' |             signed 4-byte quantities and consist of a default offset, a low offset, and a           |
' |             high offset, followed by additional high - low + 1 offsets. These additional            |
' |             offsets are treated as a 0-based jump table.                                            |
' |             The index the offsets point to must be an integer. If the index is less than            |
' |             the low offset or greater than the high offset, the default offset is added to          |
' |             the address of the current instruction. Otherwise, the low offset is subtracted         |
' |             from the index, and the element at the position index - low offset in the jump          |
' |             table is extracted and added to the address of the current instruction.                 |
' `-----------------------------------------------------------------------------------------------------'

Opc_TABLESWITCH
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             LOOKUPSWITCH                                                                        $55 |
' |             Meaning: Access jump table by key match and jump.                                       |
' |             Description: Immediately after the lookupswitch instruction, padding                    |
' |             consisting of 0-3 zeros is                                                              |
' |             inserted so that the next byte begins at an address that is a multiple of               |
' |             four. A series of pairs of offsets follows the padding. These offsets are               |
' |             signed 4-byte quantities. The first item in the pair is the default offset, and         |
' |             the second item in the pair gives the number of pairs that follow. The                  |
' |             additional pairs consist of a match and an offset.                                      |
' |             The integer key on the stack is then compared against each of the matches. If           |
' |             the key is equal to one of the matches, the offset is added to the address of           |
' |             the current instruction. If the key does not match any of the matches, the              |
' |             default offset is added to the address of the current instruction.                      |
' `-----------------------------------------------------------------------------------------------------'

Opc_LOOKUPSWITCH
                jmp     #HandleWithSpin
                jmp     #PushLhsThenFetch

' .-----------------------------------------------------------------------------------------------------.
' |             End of LMM Code                                                                         |
' `-----------------------------------------------------------------------------------------------------'

LmmCodeEnd

DAT

' *******************************************************************************************************
' *                                                                                                     *
' *             JVM / JEM Bytecode to execute                                                           *
' *                                                                                                     *
' *******************************************************************************************************

JemBytecodeStart

FILE "testJVM.jem"

JemBytecodeEnd

